##parameters=REQUEST=None, theme=None, **kw

tmtool = context.portal_themes
mcat = context.cpsskins_getlocalizer()

if REQUEST is not None:
    kw.update(REQUEST.form)

cacheable_templets = kw.get('cache', [])
if cacheable_templets:
     theme_container = tmtool.getEffectiveThemeContainer(theme=theme)
     pageblocks =  theme_container.getPageBlocks()
     for pageblock in pageblocks:
         maxcols = pageblock['maxcols']
         objects = pageblock.getObjects(REQUEST=REQUEST) 
         for xpos in range(int(maxcols)):
             objects_in_xpos = objects.get(xpos, None)
             if not objects_in_xpos:
                 continue
             for templet in objects_in_xpos['templets']:
                if templet.getId() in cacheable_templets:
                    templet.manage_changeProperties(cacheable=1)
                else:
                    templet.manage_changeProperties(cacheable=0)

if REQUEST is not None:
     url = REQUEST['HTTP_REFERER'] 
     REQUEST.RESPONSE.redirect(url)
